
cc.Class({
    extends: cc.Component,

    properties: {
        txtMessage: cc.EditBox,
        lblMessage: cc.Label
    },

    start() {
        this.connection = new signalR.HubConnectionBuilder()
            .withUrl("http://localhost:42391/signalr", {
                skipNegotiation: true,
                transport: signalR.HttpTransportType.WebSockets
            })
            .configureLogging(signalR.LogLevel.Trace)
            .build();

        this.connection.start().then(() => {
            this.lblMessage.string = 'Connected!';
        }).catch((err) => {
            this.lblMessage.string = err.toString();
        });
        
        this.connection.on('Send', (nick, message) => {
            this.lblMessage.string = `${nick}: ${message}`;
        });

        this.connection.on('ReceiveSystemMessage', (message) => {
            this.lblMessage.string = `system: ${message}`;
            this.connection.invoke('Send', 'account_test', message);
        });
    },

    sendClick(event) {
        let message = this.txtMessage.string;
        this.connection.invoke('Send', 'account_test', message);
    }
});
